h50589
s 00045/00000/00000
d D 1.1 82/08/03 08:44:11 cecily 1 0
e
u
U
t
T
I 1
/*
 * Unix routine to do an "fopen" on file descriptor
 * The mode has to be repeated because you can't query its
 * status
 */

#include	<stdio.h>
#include	<errno.h>

FILE *
fdopen(fd, mode)
	register char *mode;
{
	register FILE *iop;
	FILE *_findiop();

	if ((iop = _findiop()) == NULL)
		return(NULL);

	iop->_cnt = 0;
	iop->_file = fd;
	switch (*mode) {

	case 'r':
		iop->_flag |= _IOREAD;
		break;

	case 'a':
		lseek(fd, 0L, 2);
		/* No break */
	case 'w':
		iop->_flag |= _IOWRT;
		break;

	default:
		return(NULL);
	}

	if (mode[1] == '+') {
		iop->_flag &= ~(_IOREAD|_IOWRT);
		iop->_flag |= _IORW;
	}

	return(iop);
}
E 1
